Index: src/edu/ucsb/nceas/metacat/DBSAXHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBSAXHandler.java	(revision 1216)
+++ src/edu/ucsb/nceas/metacat/DBSAXHandler.java	(revision 1217)
@@ -58,7 +58,7 @@
    private boolean 	stackCreated = false;
    private Stack 	  nodeStack;
    private Vector   nodeIndex;
-   private Connection	  conn = null;
+   private DBConnection	  connection = null;
    private DocumentImpl currentDocument;
    private DBSAXNode    rootNode;
    private String   action = null;
@@ -80,8 +80,8 @@
     *
     * @param conn the JDBC connection to which information is written
     */
-   public DBSAXHandler(Connection conn) {
-     this.conn = conn;
+   public DBSAXHandler(DBConnection conn) {
+     this.connection = conn;
      this.atFirstElement = true;
      this.processingDTD = false;
 
@@ -106,7 +106,7 @@
     *        resides.
     *
     */
-   public DBSAXHandler(Connection conn, String action, String docid, 
+   public DBSAXHandler(DBConnection conn, String action, String docid, 
                       String user, String[] groups, String pub, int serverCode)
    {
      this(conn);
@@ -133,7 +133,7 @@
     *        resides.
     *
     */
-   public DBSAXHandler(Connection conn, String action, String docid, 
+   public DBSAXHandler(DBConnection conn, String action, String docid, 
      String revision, String user, String[] groups, String pub, int serverCode)
    {
      this(conn);
@@ -152,7 +152,7 @@
      MetaCatUtil.debugMessage("start Document", 50);
 
      // Create the document node representation as root
-     rootNode = new DBSAXNode(conn, this.docid);
+     rootNode = new DBSAXNode(connection, this.docid);
      // Add the node to the stack, so that any text data can be 
      // added as it is encountered
      nodeStack.push(rootNode);
@@ -214,23 +214,43 @@
        rootNode.writeNodename(docname);
        try {
          // for validated XML Documents store a reference to XML DB Catalog
+         // Because this is select statement and it needn't to roll back if
+         // insert document action fialed.
+         // In order to decrease DBConnection usage count, we get a new 
+         // dbconnection from pool
          String catalogid = null;
+         DBConnection dbConn = null;
+         int serialNumber = -1;
+         
          if ( systemid != null ) {
-           Statement stmt = conn.createStatement();
-           ResultSet rs = stmt.executeQuery(
+           try
+           {
+            // Get dbconnection
+            dbConn=DBConnectionPool.getDBConnection
+                                          ("DBSAXHandler.startElement");
+            serialNumber=dbConn.getCheckOutSerialNumber();
+            
+            Statement stmt = dbConn.createStatement();
+            ResultSet rs = stmt.executeQuery(
                           "SELECT catalog_id FROM xml_catalog " +
                           "WHERE entry_type = 'DTD' " + 
                           "AND public_id = '" + doctype + "'");
-           boolean hasRow = rs.next();
-           if ( hasRow ) {
-            catalogid = rs.getString(1);
-           }
-           stmt.close();
+            boolean hasRow = rs.next();
+            if ( hasRow ) {
+              catalogid = rs.getString(1);
+            }
+            stmt.close();
+           }//try
+           finally
+           {
+             // Return dbconnection
+             DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+           }//finally
          }
          
          //create documentImpl object by the constructor which can specify
          //the revision
-         currentDocument = new DocumentImpl(conn, rootNode.getNodeID(), 
+         currentDocument = new DocumentImpl(connection, rootNode.getNodeID(), 
                                docname, doctype, docid, revision, action, user, 
                                this.pub, catalogid, this.serverCode);
          
@@ -242,7 +262,7 @@
      }      
 
      // Create the current node representation
-     currentNode = new DBSAXNode(conn, qName, localName, parentNode,
+     currentNode = new DBSAXNode(connection, qName, localName, parentNode,
                                  currentDocument.getRootNodeID(),docid,
                                  currentDocument.getDoctype());
                                
@@ -275,16 +295,18 @@
   public void run () {
     DBSAXNode currNode = null;
     DBSAXNode prevNode = null;
-    Connection dbconn = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
     String doctype = currentDocument.getDoctype();
     int step = 0;
     int counter = 0;
 
     try {
+      
       // Opening separate db connection for writing XML Index
-      MetaCatUtil util = new MetaCatUtil();
-      dbconn = util.openDBConnection();
-      dbconn.setAutoCommit(false);
+      dbConn=DBConnectionPool.getDBConnection("DBSAXHandler.run");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      dbConn.setAutoCommit(false);
       
       //the following while loop construct checks to make sure that the docid
       //of the document that we are trying to index is already
@@ -296,7 +318,9 @@
       {
         String xmlDocumentsCheck = "select distinct docid from xml_documents";
         PreparedStatement xmlDocCheck = 
-                                  dbconn.prepareStatement(xmlDocumentsCheck);
+                                 dbConn.prepareStatement(xmlDocumentsCheck);
+        // Increase usage count
+        dbConn.increaseUsageCount(1);
         xmlDocCheck.execute();
         ResultSet doccheckRS = xmlDocCheck.getResultSet();
         boolean tableHasRows = doccheckRS.next();
@@ -322,13 +346,14 @@
       Enumeration nodes = nodeIndex.elements();
       while ( nodes.hasMoreElements() ) {
         currNode = (DBSAXNode)nodes.nextElement();
-        currNode.updateNodeIndex(dbconn, docid, doctype);
+        currNode.updateNodeIndex(dbConn, docid, doctype);
       }
+      
     
-      dbconn.commit();
+      dbConn.commit();
          
       //if this is a package file
-      String packagedoctype = util.getOption("packagedoctype");
+      String packagedoctype = MetaCatUtil.getOption("packagedoctype");
       Vector packagedoctypes = new Vector();
       
       packagedoctypes = MetaCatUtil.getOptionList(packagedoctype);
@@ -336,36 +361,44 @@
       if ( packagedoctypes.contains(doctype) )
       {
         // write the package info to xml_relation table
-        RelationHandler rth = new RelationHandler(docid, dbconn);
+        RelationHandler rth = new RelationHandler(docid, dbConn);
         // from the relations get the access file id for that package
         String aclid = rth.getAccessFileID(docid);
         // if there are access file, write ACL for that package
         if ( aclid != null ) {
-          runAccessControlList(dbconn, aclid);
+          runAccessControlList(dbConn, aclid);
         }
+        
       }
+      
       // if it is an access file
       else if ( MetaCatUtil.getOptionList(
-                            util.getOption("accessdoctype")).contains(doctype) )
+                     MetaCatUtil.getOption("accessdoctype")).contains(doctype) )
       {
         // write ACL for the package
-        runAccessControlList(dbconn, docid);
+        runAccessControlList(dbConn, docid);
+        
       }
+     
       
-      dbconn.close();
+      //dbconn.close();
 
     } catch (Exception e) {
       try {
-        dbconn.rollback();
-        dbconn.close();
+        dbConn.rollback();
+        //dbconn.close();
       } catch (SQLException sqle) {}
       System.out.println("Error in DBSAXHandler.run " + e.getMessage());
       e.printStackTrace();
-    }      
+    }
+    finally
+    {
+      DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+    }//finally      
   }
   
   // It runs in xmlIndex thread. It writes ACL for a package.
-  private void runAccessControlList (Connection conn, String aclid)
+  private void runAccessControlList (DBConnection conn, String aclid)
                                                 throws Exception
   {
     // read the access file from xml_nodes
